<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--

Copyright (C) 2004 Fuji Xerox, Co., Ltd.. All Rights Reserved.
Copyright (C) 2004 Xerox Corporation. All Rights Reserved.

Version: $Id: my_tasks_tabbed.jsp 93076 2015-12-03 08:10:45Z bchan $
-->

<!--
This file displays the tasks assigned to me and the tasks assigned by
me as a vertical frameset.  The contents of each window can be scrolled,
and the frameset can be interactively adjusted.
-->

<html xmlns="http://www.w3.org/1999/xhtml">
<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>
<%@ page import="com.xerox.docushare.routing.TaskTypeBean" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<jsp:useBean id="taskTypeBean" scope="session" class="com.xerox.docushare.routing.TaskTypeBean">
  <jsp:setProperty name="taskTypeBean" property="*"/>
</jsp:useBean>

<%
    request.setCharacterEncoding("UTF8");
    response.setContentType("text/html; charset=UTF-8");
    DSSession dsSession = (DSSession)request.getAttribute("DSSession");
    java.util.Locale locale = dsSession.getLocale();
    DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
    boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
    String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";
    String title = MessageDB.get("routing_my_tasks", locale);
    
    // fetch parameter list to pass on to frame windows
    String params = request.getQueryString();
    if (params == null)
        params = "";
    else
        params = "?" + params;

    // default - first time entry
    if(taskTypeBean.getTaskType().length() == 0)
    {
        taskTypeBean.setTaskType(TaskTypeBean.TOME);
        //System.out.println("First time use, default to TaskTypeBean.TOME");
    }

    if(request.getParameter("taskType") != null) // user selected item in the menu
    {
        //System.out.println("request.getParameter(taskType) " + request.getParameter("taskType"));
        taskTypeBean.setTaskType(request.getParameter("taskType"));
    }

    String pageToInsert = "";
    if(taskTypeBean.getTaskType().equals(TaskTypeBean.TOME))
    {
        pageToInsert = "tasks_assigned_to_me.jsp";
    }
    else if(taskTypeBean.getTaskType().equals(TaskTypeBean.BYME))
    {
        pageToInsert = "tasks_assigned_by_me.jsp";
    }
    else if(taskTypeBean.getTaskType().equals(TaskTypeBean.ALL))
    {
        pageToInsert = "tasks_all.jsp";
    }
    else if(taskTypeBean.getTaskType().equals(TaskTypeBean.HISTORY))
    {
        pageToInsert = "tasks_history.jsp";
    }
    else if(taskTypeBean.getTaskType().equals(TaskTypeBean.UNCLASSIFIED))
    {
        pageToInsert = "tasks_unclassified.jsp";
    }
%>
<HEAD>
  <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE" />
  <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
  <TITLE><%= title %></TITLE>

   
  <script language="javascript">
  <!--
  function selectAssignedToMe()
  { 
  }
  function selectAssignedByMe()
  {
  }
  //-->
  <%@include file="document_routing.js" %>
  </script>

  <%@ include file="ThemeUtil.jsp" %>
  
  <%
  // DocuShare Base CSS
  %>
  <link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
  <style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
  <%
//Market-specific styling for XC
//******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

	// Enterprise Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
	<%
	// Education Edition Licensed Site 
	} else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	}
//Market-specific styling for FX
//******************************
} else {
	// Education Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	// CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
	} else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
	<%
	}
}
%>

</HEAD>

<body>
    <div id="header">
      <h1>DocuShare</h1>
      <h2>My Tasks</h2>
      <div id="header-wrapper"><p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p></div>
		</div>
		<div id="content">
    <h2><%= title %></h2>

<form>
    <div class="colltable_toolbar">
    <%= MessageDB.get("routing_task_type_doSelect", locale) %>:
    <select name="taskType" onChange='this.form.goButton.click()'>
        <option value="<%= TaskTypeBean.TOME %>"         <%= taskTypeBean.isTypeSelected(TaskTypeBean.TOME) %>         ><%= MessageDB.get("routing_task_type_doc_to_me", locale) %></option>
        <option value="<%= TaskTypeBean.BYME %>"         <%= taskTypeBean.isTypeSelected(TaskTypeBean.BYME) %>         ><%= MessageDB.get("routing_task_type_doc_by_me", locale) %></option>
        <option value="<%= TaskTypeBean.HISTORY %>"      <%= taskTypeBean.isTypeSelected(TaskTypeBean.HISTORY) %>      ><%= MessageDB.get("routing_task_type_history", locale) %></option>
    </select>
    <INPUT class="bs" type="SUBMIT" value="<%=MessageDB.get("button.go", locale)%>" border="0" name="goButton" />
    </div>
</form>

<jsp:include page="<%= pageToInsert %>"/>

</BODY>
</html>
