<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--request_base.jsp

Copyright (C) 2004 Fuji Xerox, Co., Ltd.. All Rights Reserved.
Copyright (C) 2004 Xerox Corporation. All Rights Reserved.

Version: $Id: request_base.jsp 93076 2015-12-03 08:10:45Z bchan $
-->
<!--
This file receives notification messages from workflow activities
and queues the events for the recipient
-->

<html xmlns="http://www.w3.org/1999/xhtml">

<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.property.*" %>
<%@ page import="com.xerox.docushare.impl.util.*" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>

<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.workflow.*" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.text.SimpleDateFormat" %>

<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<% 
long t0 = System.currentTimeMillis();
// set recipient from logged user
final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
if(dsSession == null) {
    out.println("request.getAttribute(\"DSSession\") returns null!");
    return;
}
final java.util.Locale locale = dsSession.getLocale();
try{
    dsrouting.setDSSession(request); 
}catch(DSAuthorizationException e){
    response.setContentType(dsrouting.getContentType()); //AR20163
    out.print(MessageDB.get("routing_not_authorized", locale));
    return;
}
String keySuffix = dsrouting.getDateKeySuffix(); //AR8506+: after dsrouting.setDSSession(request)
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
boolean btnReadOnly = ((DSSession)request.getAttribute("DSSession")).isReadOnly(); //AR6202+
String requestURL = dsrouting.getRequestURL(request);
String contextPath = request.getContextPath();
%>

<jsp:useBean id="browserInfo" scope="session" class="com.xerox.docushare.routing.BrowserInfo">
    <% browserInfo.setUserAgent(request.getHeader("USER-AGENT")); %>
</jsp:useBean>

<%
final DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";
final String recipient = dsUser.getHandle().toExternalForm();
final String recipientName = GenericUtil.getShortName(dsUser, dsSession);

final String workFlowJobName = request.getParameter("workFlowJobName");
final String routingSlipRequestID = request.getParameter("routingSlipRequestID");
final String status = request.getParameter("status");

int routingSlipRequest = Integer.parseInt(routingSlipRequestID); 
int routingSlip = Integer.parseInt(workFlowJobName); 

HashMap routingMap = dsrouting.getRoutingInfo(routingSlip);

//AR9015+: check if routingSlipRequestID does not belong to recipient or already replied, set btnReadOnly to true:
try{
    for (Iterator recipientItr = ((ArrayList)routingMap.get("TaskID_Recipients")).iterator(); recipientItr.hasNext(); ) {
        String tid_rec = (String)recipientItr.next(); //format: "tid_uid: taskname"
        tid_rec = tid_rec.substring(0, tid_rec.indexOf(':'));
        if(tid_rec.startsWith(routingSlipRequestID)){
        		if(!tid_rec.endsWith(recipient)) {
          		  out.print(MessageDB.get("routing_not_authorized", locale));
          		  return; //btnReadOnly = true; //task recipient not match
        		}
        		//AR10712-: else if(routingMap.get(tid_rec+"_StatusTime") != null) 
        		else if(!dsrouting.isTaskActive(Integer.parseInt(routingSlipRequestID))) //AR10712+
          		  btnReadOnly = true; //task already replied
            break;
        }
    }
}catch(Exception ec) {}
//end AR9015+

final String taskType = ""+ dsrouting.getTaskType(routingSlipRequest);
String htmlTitle = ""; //routing_in_order=In Order
String requestTitle = MessageDB.get("routing_forUnknownRequest", locale);
if(taskType.indexOf("Approval")!=-1){
  requestTitle = MessageDB.get("routing_forApprovalOrderedRequest", locale);
  htmlTitle = MessageDB.get("routing_for_approval_title", locale);
}
else if(taskType.indexOf("Review")!=-1){
  requestTitle = MessageDB.get("routing_forReviewRequest", locale);
  htmlTitle = MessageDB.get("routing_forReviewRequest_title", locale);
}
else if(taskType.indexOf("Information")!=-1){
  requestTitle = MessageDB.get("routing_forInformationRequest", locale);
  htmlTitle = MessageDB.get("routing_for_information_title", locale);
}
else if(taskType.indexOf("Acknowledge")!=-1){
  requestTitle = MessageDB.get("routing_forAcknowledgeRequest", locale);
  htmlTitle = MessageDB.get("routing_for_Acknowledge_title", locale);
}
else if(taskType.indexOf("Orphan")!=-1){
  requestTitle = MessageDB.get("routing_unpublished_document", locale);  
}

//boolean inOrder = !dsrouting.hasParallelTask(routingSlipRequest); //dsrouting.hasSuccessorTask(routingSlipRequest) || dsrouting.hasPredecessorTask(routingSlipRequest);
boolean inOrder = (""+routingMap.get("Action")).endsWith("Ordered");
if(inOrder) htmlTitle += " ("+MessageDB.get("routing_in_order", locale) +")";
%>

<HEAD>
   <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE" />
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html">
  <%@ include file="ThemeUtil.jsp" %>
  
<%
// DocuShare Base CSS
%>
<link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
<%
//Market-specific styling for XC
//******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

	// Enterprise Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
	<%
	// Education Edition Licensed Site 
	} else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	}
//Market-specific styling for FX
//******************************
} else {
	// Education Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	// CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
	} else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
	<%
	}
}
%>
  
   <TITLE><%= htmlTitle %></TITLE>

<script language="javascript">
<!--
// These files included in JSP because they use request.getContextPath()

// JavaScript for document routing functions
<%@include file="document_routing.js" %>
function disableRestButtons()
{
  reqbase.subApprove.disabled=true;
  reqbase.subResLater.disabled=true;
  reqbase.subDisapprove.disabled=true;
}
//-->
</script>

<%
// Singapore team AR2697 Only show hint when for review and document is not locked.
boolean showAddDraftHint = true;
// Singapore team AR2697

if (dsrouting == null) {%>
    <script language="javascript">
    <!--
    writeError(document, '<%= recipientName %>', 'Error', '%= MessageDB.get("routing_contact_failed", locale) %>');
    //-->
    </script>

<%} else if (recipient == null) {%>
    <script language="javascript">
    <!--
    writeError(document, '<%= recipientName %>', 'Internal Error', '<%= MessageDB.get("routing_missing_recipient", locale) %>');
    //-->
    </script>

<%} else if (routingSlipRequestID == null) {%>
    <script language="javascript">
    <!--
    writeError(document, '<%= recipientName %>', 'Internal Error', '<%= MessageDB.get("routing_error_missing_parameter", locale) %>');
    //-->
    </script>
  
<%} else if (routingSlip == 0) {%>
    <script language="javascript">
    <!--
    writeError(document, '<%= recipientName %>', 'Error', '<%= MessageDB.get("routing_slip_not_available", locale) %>');
    //-->
    </script>

<%// handle results of form submission
} else if (status != null) {
    boolean error = false;
    try {
        // record user response and comments with routing slip
        //dsrouting.setRecipientStatus(routingSlip, recipient, status);  //setStatus
        String comment = request.getParameter("comment");
        //AR10963, 2006-1-6: routingSlip -> routingSlipRequest:
        dsrouting.setRecipientComment(routingSlipRequest, recipient, (comment==null) ? "" : comment);
        // remove notification
        if(!status.equals("Respond Later")) {//AR8368+
            if(request.getParameter("setCommentPrivate")!=null) dsrouting.setCommentPrivate(routingSlipRequest);
            dsrouting.removeWorkFlowTaskForUser(recipient, routingSlipRequest, status);
        }
    } catch (IllegalStateException ex) {
        error = true;
        out.print("error: "+ ex);
        %>
        <script language="javascript">
        <!--
        writeError(document, '<%= recipientName %>', 'Error', '<%= ex.getMessage() %>');
        //-->
        </script>
    <%} catch (java.rmi.RemoteException ex) {
        error = true;
        out.print("error: "+ ex);
        ex.printStackTrace();
        %>
        <script language="javascript">
        <!--
        writeError(document, '<%= recipientName %>', 'Error', '<%= MessageDB.get("routing_error_encountered", locale) %>');
        //-->
        </script>
    <%}%>

    <script language="javascript">
    <!--
    // Singapore team AR4549 On Netscape, request windows do not close after submit
    // update the My Tasks Assigned To Me pane if open
    try {//15200+ try
        var win = updateMyTasksAssignedToMe();
        // refresh opener if not the Assigned To Me pane
        if (self.opener && (self.opener != win)) {
            self.opener.location = self.opener.location;
        }
    }catch(err){
        window.close();
    }//end 15200+
    
    <%if (!error) {%>
        window.close();
    <%}//Singapore team AR4549
    %>
    //-->
    </script>
    
<%} else { //display
    try {%>
    </head>
        
    <body>
    <div id="header">
        <h1>DocuShare</h1>
        <h2>Review and Change</h2>
        <div id="header-wrapper"><p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p></div>
    </div>
    
    <div id="content">
    <h2><%= requestTitle %></h2>
        <%
        String subject = (String)routingMap.get("Subject"); //dsrouting.getSubject(routingSlip);
        if (subject.length() == 0) {
            Iterator itrDoc = ((ArrayList)routingMap.get("Documents")).iterator();
            if(itrDoc.hasNext()){
                String doc = (String)itrDoc.next();
                try{
                    DSHandle dsHandle = new DSHandle(doc);
                    DSObject dsObj = dsSession.getObject(dsHandle, new DSSelectSet(DSObject.title)); //AR13400
                    if (dsObj instanceof DSVersion) {
                        // get document from version
                        dsObj = ((DSVersion)dsObj).getDocument(DSSelectSet.NO_PROPERTIES);
                    }
                    // use the first document as the subject if no subject given
                    subject = dsObj.getTitle();
                }catch(Exception e1) {
                    try{
                        ArrayList docTitleArray = (ArrayList)routingMap.get("DocTitleArray");
                        if(docTitleArray!=null && docTitleArray.size()>0) 
                            subject = (String)docTitleArray.get(0);
                        //else subject = doc;
                    }catch(Exception e2) {}
                }
            }
        }//if(subject.length()==0)

        String owner = (String)routingMap.get("Owner"); //dsrouting.getWorkFlowOwner(routingSlip);        
        String ownerName = dsrouting.getUserFullName(owner);
        if(owner==null || owner.equals("null")) owner = "";

        if(ownerName.startsWith("routing_")) {//routing_deleted, routing_no_access //AR13848
            String ownerName_save = (String)routingMap.get("OwnerName");
            if (ownerName_save != null && ownerName_save.length() > 0)
                ownerName = ownerName_save + " ("+ MessageDB.get(ownerName, locale)+")";
            else
            		ownerName = owner + " ("+ MessageDB.get(ownerName, locale)+")";
        }
        %>
    <p>
    <strong><%= MessageDB.get("prop.label.linksFromAbbr", locale) %>:</strong>&nbsp;<%= ownerName %><br />
    <strong><%= MessageDB.get("routing_subject", locale) %>:</strong>&nbsp;<%= AmberUtility.xss_safe_value(subject) %><br />        
        <%
        if (routingSlipRequest != 0) {
            Date requestTime = (Date)routingMap.get("ActiveTime"); 
            if(requestTime == null) 
                requestTime = dsrouting.getTaskCreationTime(routingSlipRequest);
            // Singapore team AR3594 in International English version  due date is not right 
            String requestTimeStr = new SimpleDateFormat(MessageDB.get("date_time_full"+keySuffix, locale), locale).format(requestTime);
            %>
    <strong><%= MessageDB.get("date_label", locale) %>:</strong>&nbsp;<%= requestTimeStr %><br /> 
            <%
            Date dueTime = (Date)routingMap.get("ByDate"); //dsrouting.getWorkFlowByDate(routingSlip);
            if (dueTime != null) {
                String dueTimeStr = new SimpleDateFormat(MessageDB.get("date_long"+keySuffix, locale), locale).format(dueTime);
                // Singapore team AR3594
                %>
    <strong><%= MessageDB.get("routing_due_date", locale) %>:</strong>&nbsp;<%= dueTimeStr %>
                <%
                if (dueTime.before(new Date())) {
                    %>
    <font color="red"> <strong>(<%= MessageDB.get("routing_overdue", locale) %>)</strong></font>
                    <%
                }
            }
        }//end if
        %>
    </p>

    <p>
        <%= AmberUtility.xss_safe_value(((String)routingMap.get("Body")).replaceAll("\r","<br>")) %>
    </p>

    <table class="colltable">
        <col class="col_actions" />
        <col class="col_actions" />
        <tr>
            <th><%=MessageDB.get("routing_type", locale)%></th>
            <th class="name"><%=MessageDB.get("routing_title", locale)%></th>
            <th class="actions"><%=MessageDB.get("Actions", locale)%></th> 
        </tr>
        <%
        DSURLInfo urlInfo = (DSURLInfo) request.getAttribute("DSURLInfo");
        boolean first = true;
        ArrayList docTitleArray = (ArrayList)routingMap.get("DocTitleArray");

        ArrayList docList = (ArrayList)routingMap.get("Documents");
        if(docList == null) docList = new ArrayList();
        for(int n=0; n<docList.size(); n++){
            String docEntry = (String)docList.get(n);
            String draft = ""+ routingMap.get(docEntry+ "_RoutedVersion");
            String myDraft = (String)routingMap.get(docEntry+ "_"+ recipient);
            if(myDraft != null) 
                draft = myDraft;
            else{//no my draft, get LastReviewDraft to accumulate redlines
                String lastDraft = (String)routingMap.get(docEntry+ "_LastReviewDraft");
            if(lastDraft != null) 
                draft = lastDraft;
            }
            
            String errMsg = "";
            DSHandle draftHandle = new DSHandle(draft);
            DSObject dsObj = null;
            DSDocument dsDoc = null;
            DSVersion dsVersion = null;
            String versionFileName = "";
	    	String lostSimpleDocTitle = null; //AR23531
            try {
              dsObj = dsSession.getObject(draftHandle, new DSSelectSet(new String[] 
                {DSObject.summary, DSObject.title, DSObject.isRecord})); //AR13400
              if(dsObj instanceof DSDocument){
                dsDoc = (DSDocument)dsObj;
                dsVersion = dsDoc.getPreferredVersion(DSSelectSet.NO_PROPERTIES); //null
                //update draft and draftHandle to version's:
                draftHandle = dsVersion.getHandle();
                draft = draftHandle.toExternalForm();

              }else if(dsObj instanceof DSVersion){
                dsVersion = (DSVersion)dsObj;
                dsDoc = dsVersion.getDocument(DSSelectSet.NO_PROPERTIES);
                dsObj = dsDoc;
              }else{
              	;//throw new IllegalStateException("Specified object is not a version.");
              }
				//AR23531: try to look for the 1st version of the SimpleDoc, this is to handle old workflow created on SimpleDoc before AR23531 is fixed
				if( (""+dsVersion.getHandle()).startsWith("v_Document-") && !dsSession.isSimpleDoc( ( ( DSDocument ) dsDoc ).getHandle() ) ){
				
				
					DSObjectIterator versionsIter = dsDoc.getDestinations( new String[]{ DSLinkDesc.version, DSLinkDesc.draftVersion }, 1, new DSSelectSet(new String[] {DSVersion.version_number}) );
					boolean foundFirst = false;
					while (versionsIter.hasNext())
					{
						DSVersion dsVer = (DSVersion) versionsIter.next();
						if(dsVer.getVersionNumber() == 1)
						{
							dsObj = dsSession.getObject(dsVer.getHandle(), new DSSelectSet(new String[] {DSObject.summary, DSObject.title, DSObject.isRecord})); //AR13400
				              		if(dsObj instanceof DSDocument){
				                		dsDoc = (DSDocument)dsObj;
				                		dsVersion = dsDoc.getPreferredVersion(DSSelectSet.NO_PROPERTIES); //null
				                		draftHandle = dsVersion.getHandle();
				                		draft = draftHandle.toExternalForm();
					              	}else if(dsObj instanceof DSVersion){
				                		dsVersion = (DSVersion)dsObj;
				                		dsDoc = dsVersion.getDocument(DSSelectSet.NO_PROPERTIES);
				                		dsObj = dsDoc;
								draftHandle = dsVersion.getHandle();
				                		draft = draftHandle.toExternalForm();
				              		}else{
				              		}
							foundFirst = true;
							break;
						}
					}
					if (!foundFirst)
					{
						errMsg = " ("+MessageDB.get("routing_deleted", locale)+")";
						lostSimpleDocTitle = dsDoc.getTitle()+errMsg;
						dsObj = null;
						dsDoc = null;
						dsVersion = null;
					}
				}
              // get preferred file name for use in GET request
              if(dsVersion!=null) {
                versionFileName = dsVersion.getPreferredRendition(DSSelectSet.NO_PROPERTIES).getContentElements()[0].getPreferredFileName();
                versionFileName = dsrouting.removePoisonChars(versionFileName); //AR11042+
              }
            }
            catch(DSException e) {//AR18174+
				String errStr = "" + e;
				if(e.errorCode == DSException.NOT_FOUND) {
				    boolean deleted = false;
				    try{
						deleted = dsSession.isDeletedObject(draftHandle);
				    }
				    catch (DSAuthorizationException aex){
						errMsg = " ("+MessageDB.get("routing_no_access", locale)+")"; 
						System.out.println("request_base.jsp display list of documents "+ draft +": errorCode " + e.getErrorCode() + ", " + aex);
				    }
				    catch (DSException ex){
						deleted = true;
						System.out.println("request_base.jsp display list of documents "+ draft +": errorCode " + e.getErrorCode() + ", " + ex);
				    }
				    if (deleted)
				    {
						errMsg = " ("+MessageDB.get("routing_deleted", locale)+")";
						System.out.println("request_base.jsp display list of documents "+ draft +": errorCode " + e.getErrorCode() + ", " + e);
				    }
				    else
						System.out.println("request_base, "+ draft +": " + errStr);
                } else
                    System.out.println("request_base, "+ draft +": " + errStr);
            }
            catch(Exception e) { System.out.println("request_base, "+ draft +": " + e); }
            
            // get the icon, title and summary for the draft version
            String docIcon = contextPath + "/images/small/page.png";
            if (urlInfo != null) {
                try {
                    java.net.URL docIconURL = new java.net.URL(urlInfo.getURLInfo(draftHandle)[0]);
                    docIcon = docIconURL.getPath();
                } catch (Exception ex) {
                }
            }
            String errTitle = draft;
            if(docTitleArray!=null && docTitleArray.size()>n)
                errTitle = (String)docTitleArray.get(n);
            String docTitle = (dsObj == null) ? errTitle+errMsg : dsObj.getTitle(); //AR6175: dsVersion->dsDoc
	    	if (lostSimpleDocTitle != null)
				docTitle = lostSimpleDocTitle;
            String docSummary = (dsObj == null) ? null : dsObj.getSummary(); //AR6175: dsVersion->dsDoc
            //System.out.println("docTitle = "+ docTitle);

            if (!first) {
                %>
        <!-- draw a rule above each item in the list -->
        <!-- <TR><TD class='list-rule' colspan='3'><SPACER height='1px' type='block'></TD></TR> -->
                <%
            }
            first = false;
            %>
    <tr>
        <td class="icon">
            <% //AR8786+:
            String GetOrView = "/dsweb/Get/" + draft + "/";
            boolean isInteract = false;
            try{
                if(dsDoc == null) //AR12002+
                    GetOrView = "/dsweb/View/" + draft + "/";
                else //dsDoc not null
                    isInteract = dsDoc.getIsInteract();
                if(isInteract) GetOrView = "/dsweb/View/" + dsObj.getHandle().toString() + "/";
            }catch(Exception e0) {System.out.println("dsDoc.getIsInteract(): "+ e0); }
            //end AR8786
            
            if(errMsg.length()==0){%>
            <!-- AR8786 DSDE: fix interact page routing -->
            <a href="<%= contextPath + GetOrView + versionFileName %>" target="_new">
            <%}%>
            <img <%= browserInfo.getImgWrapper(docIcon) %> alt="<%= MessageDB.get("Document", locale) %>" title="<%= MessageDB.get("Document", locale) %>" border="0" />
            </a>
        </TD>
            
        <td class="name">
            <%if(errMsg.length()==0){%>
            <!-- AR8786 DSDE: fix interact page routing -->
            <a class="uline" href="<%= contextPath + GetOrView + versionFileName %>" target="_new">
            <%}%>
            <%= AmberUtility.xss_safe_value(docTitle) %>
            </a>
            <%
            if (docSummary != null) {%>
                <p><%= AmberUtility.xss_safe_value(docSummary) %></p>
            <%}%>
        </td>
        
        <td class="actions"> 
            <%
            String sProperties = MessageDB.get("routing_tooltip_properties", locale); //SDL AR9150+
            String sViewHTML = MessageDB.get("routing_tooltip_view_html", locale); //SDL AR9150+
            
            if(errMsg.length()==0 & !btnReadOnly){
                if(dsDoc == null) {//AR12002+ %>
            <a href="<%= contextPath %>/dsweb/Services/<%= draft %>" target="_new">
                <%}else{%>
            <a href='prop_all.jsp?document=<%= draft %>&return=<%= java.net.URLEncoder.encode("request_base.jsp?" + request.getQueryString(), "UTF-8") %>&returnTag=<%= java.net.URLEncoder.encode(requestTitle, "UTF-8") %>&aboutRecipient=<%= recipient %>&<%= request.getQueryString() %>'>
                <%}
            }%>
            <img <%= browserInfo.getImgWrapper("images/action_properties.gif") %> alt="<%=sProperties%>" title="<%=sProperties%>" /></a>
            <% // Singapore team AR2768 Hide remark from enduser // Singapore team AR2658 Remove sub-route icon %>
            <%
            //AR9778+:
            boolean isRecord = true;
            try{ 
                if(dsVersion!=null)
                    isRecord = dsVersion.getIsRecord();
                else if(dsObj!=null)
                    isRecord = dsObj.getIsRecord();
            }catch(Exception ev) { System.out.println("dsVersion.getIsRecord(): "+ev); }
            //end AR9778+
            try{
            boolean enableHtmlview = jp.co.fujixerox.docushare.amber.ConfigManager.getInstance().getDSConfig().enableHtmlview (dsSession); //AR8883+
            enableHtmlview = enableHtmlview && !isRecord; //AR9778+
            //System.out.println("urlInfo = " + urlInfo);
            if (urlInfo != null && urlInfo.is_viewable(draftHandle) && enableHtmlview && errMsg.length()==0) {%>
                <a href="<%= contextPath %>/dsweb/Get/<%= draft %>/html" target="_new">
                <img <%= browserInfo.getImgWrapper(contextPath + "/images/action_viewweb.gif") %> alt="<%=sViewHTML%>" title="<%=sViewHTML%>" /></a>
            <%}
            /* AR15049-: //AR9639 PDF icon:
            String sourceMimeType = dsVersion.getPreferredRendition(new DSSelectSet(DSRendition.rendition_type)).getRenditionType();
            boolean viewPdf = dsSession.canConvert(sourceMimeType, "application/pdf") && !isRecord;
            //System.out.println("sourceMimeType = " + sourceMimeType + ", viewPdf = " + viewPdf);
            String sViewPDF = MessageDB.get("routing_tooltip_view_pdf", locale);
            if (viewPdf && errMsg.length()==0) {%>
                <a href="<%= contextPath %>/dsweb/Get/<%= draft %>/pdf" target="_new">
                <img <%= browserInfo.getImgWrapper(contextPath + "/images/action_viewPDF.gif") %> alt="<%=sViewPDF%>" title="<%=sViewPDF%>" /></a>
            <%}
            //end AR9639*/
            }catch(Exception ev) { //System.out.println("urlInfo.is_viewable: "+ev); 
            }
            %>
        </TD>
    </TR>
            <%
            // Singapore team AR2697 Only show hint when document is not locked and not a record.
            boolean locked = false;
            try { 
                if(dsDoc != null) locked = dsDoc.isLocked();
            } catch(Exception e) {
            //AR5108-: out.println("dsVersion.getDocument(DSSelectSet.NO_PROPERTIES).isLocked(): "+e); 
            }
            //AR9778-: showAddDraftHint = showAddDraftHint || locked;
            showAddDraftHint = showAddDraftHint && !locked && !isRecord; //AR9778+
            
            //AR6441: add link for "Latest Published Version":
            DSVersion latestVer = null;
            try{
            if(dsDoc != null && !dsDoc.isDraft()) //AR20695: for draft, do not show "Latest Published Version"
              for(DSObjectIterator vers = dsDoc.getVersions(DSSelectSet.NO_PROPERTIES); vers.hasNext(); ){
                DSVersion dsVer = (DSVersion)vers.nextObject();
                if(latestVer == null || latestVer.getVersionNumber()<dsVer.getVersionNumber()) 
                  latestVer = dsVer;
              }
            }catch(Exception e) { System.out.println("request_base get latestVer: "+ e); }
            if(latestVer != null){
              String sLatestVer = latestVer.getHandle().toString();
              if(!draft.equals(sLatestVer)){
                String verFileName = latestVer.getPreferredRendition(DSSelectSet.NO_PROPERTIES)
                .getContentElements()[0].getPreferredFileName();
                verFileName = dsrouting.removePoisonChars(verFileName); //AR11042+
                //AR8786 DSDE: don't show Latest Published Version for Interact Pages
                if (!isInteract) {
              %>
              
            <tr><td> </td><td class="name">
            <a class="uline" href="<%= contextPath %>/dsweb/Get/<%= sLatestVer %>/<%= verFileName %>" target="_new">
            &nbsp <%=MessageDB.get("routing_latest_version", locale)%> 
            </a></TD></tr>
              <%
                }
              }
            }
            //end "Latest Published Version"
            
            //add link for "ShareReview": Uploaded Version by XXX
            try{
              String doc = dsObj.getHandle().toString();
              //loop routingMap keys for added drafts:
              ArrayList AddedDrafts = new ArrayList();
              for(Iterator itrKey = routingMap.keySet().iterator(); itrKey.hasNext(); ){
                String key = (String)itrKey.next();              
                if(key.endsWith("_ShareReview")) {//tid_rec+"_ShareReview"
                  String rec = key.substring(key.indexOf('_')+1, key.lastIndexOf('_'));
                  String addedDraft = (String)routingMap.get(doc+"_"+rec);
				  // AR 29693: [ds661u3] FX 88892 Displayed two "Uploaded draft by UserX" rows
                  if(addedDraft != null  && !AddedDrafts.contains(addedDraft)){
				    AddedDrafts.add(addedDraft);
                    String verFileName = ((DSVersion)dsSession.getObject(new DSHandle(addedDraft), DSSelectSet.NO_PROPERTIES))
                    .getPreferredRendition(DSSelectSet.NO_PROPERTIES).getContentElements()[0].getPreferredFileName();
                    verFileName = dsrouting.removePoisonChars(verFileName); //AR11042+
                    String uName = GenericUtil.getShortName((DSUser)dsSession.getObject(new DSHandle(rec), DSSelectSet.NO_PROPERTIES), dsSession);
            %>
            <tr><td> </td><td class="name">
            <a class="uline" href="<%= contextPath %>/dsweb/Get/<%= addedDraft %>/<%= verFileName %>" target="_new">
            &nbsp <%= MessageDB.get("routing_uploaded_draft_by", new Object[]{uName}, locale) %>
            </a></TD></tr>
            <%
                  }//if addedDraft
                }//if _ShareReview
              }//for key
            }catch(Exception es) {System.out.println("request_base.jsp ShareReview: "+es); }
            //end "ShareReview"
            
        }//end for doc
        // Singapore team AR2697
        %>
    </TABLE>
        <%
        // Singapore team AR2697 Only show hint when document is not locked.
        if(taskType.indexOf("Review")!=-1 && showAddDraftHint){
            // Singapore team AR2661 Modified add draft hint
            %>
            <p class="note"><%= MessageDB.get("routing_draft_hint", locale) %></p>
            <%
        }
        // Singapore team AR2697
        %>

        <%/* Singapore team AR3518 */
        int majorVersion = browserInfo.getPropertyAsInt("majorVersion");
        int minorVersion = browserInfo.getPropertyAsInt("minorVersion");
        boolean isOlderNetscape =    "Netscape".equals(browserInfo.getProperty("browserType"))
                                  && ((majorVersion <= 4) || ((majorVersion == 6) && (minorVersion == 1)));
        //AR8368+: load Respond Later comments:
        String savedComments = "";
        if(routingSlipRequestID != null){
            for (Iterator recipientItr = ((ArrayList)routingMap.get("TaskID_Recipients")).iterator(); recipientItr.hasNext(); ) {
                String tid_rec = (String)recipientItr.next(); //format: "tid_uid: taskname"
                tid_rec = tid_rec.substring(0, tid_rec.indexOf(':'));                
                if(tid_rec.startsWith(routingSlipRequestID)){
                    savedComments = (String)routingMap.get(tid_rec+"_Comment");
                    break;
                }
            }
        }
        if(savedComments == null) savedComments = "";
        //end AR8368+
        %>
        
    <form name="reqbase" action="request_base.jsp" target="_top" method="POST" onsubmit="disableRestButtons()"> <!-- AR21784 change GET to POST -->
        
    <label for="comment"><%=MessageDB.get("comment_label", locale)%></label><br/> 
		<textarea class="fullWidthTextArea" rows="4" name="comment" tabindex="10"><%=AmberUtility.xss_safe_value(savedComments)%></textarea><br/>
		<input type="checkbox" name="setCommentPrivate" /> 
		<label for="setCommentPrivate"><%=MessageDB.get("routing_save_private", locale)%></label>
    <p> </p>
        <%
        // AR3684 start: display other recipients comments
        //if(dsrouting.hasPredecessorTask(routingSlipRequest))
        {
          for (Iterator recipientItr = ((ArrayList)routingMap.get("TaskID_Recipients")).iterator(); recipientItr.hasNext(); ) {
            String tid_rec = (String)recipientItr.next(); //format: "tid_uid: taskname"
            tid_rec = tid_rec.substring(0, tid_rec.indexOf(':'));
            if(routingMap.get(tid_rec+"_StatusTime") == null) continue; //AR8368+: skip "Respond Later" comments
            String aRecipient = tid_rec.substring(tid_rec.indexOf('_')+1);
            String aTask = tid_rec.substring(0, tid_rec.indexOf('_'));

            String aRecipientName = dsrouting.getUserFullName(aRecipient);
            if(aRecipientName.startsWith("routing_")) //routing_deleted, routing_no_access
              aRecipientName = routingMap.get(aRecipient + "_fullname") + " ("+ MessageDB.get(aRecipientName, locale)+")"; //AR13848
            String comments = (String)routingMap.get(tid_rec+"_Comment"); //dsrouting.getRecipientComment(routingSlip, aRecipient);
            if(comments == null) comments = "";
            if(!comments.equals("") || aRecipientName.indexOf("<a href")!=-1){
              String usercomments = "<strong>"+ aRecipientName + " " + MessageDB.get("routing_comments", locale) + ": </strong>";
              if(routingMap.get(tid_rec+"_PrivateComment") == null) //public comment
                comments = usercomments + AmberUtility.xss_safe_value(comments);
              else //PrivateComment
                comments = usercomments + MessageDB.get("routing_private_comments", locale);
              %>
              <p><%=comments%></p>
              <%
            }
          }// AR3684 end for
        }//end if hasPredecessor
        %>
    <div id="buttonbar">
        <%
        String btnYes = MessageDB.get("button.ok", locale);
        String btnNo = MessageDB.get("No", locale);
        String btnCancel = MessageDB.get("button.cancel", locale);
        String statusValue = "";
        if(taskType.equals("Approval")){
          btnYes    = MessageDB.get("routing_approved", locale);
          btnNo     = MessageDB.get("routing_disapproved", locale);
          btnCancel = MessageDB.get("routing_respond_later", locale);
          statusValue = "Approved";
        }
        else if(taskType.equals("Review")){
          btnYes    = MessageDB.get("routing_reviewed", locale);
          btnCancel = MessageDB.get("routing_reviewed_later", locale);
          statusValue = "Reviewed";
        }
        else if(taskType.equals("Acknowledge")){
          btnYes    = MessageDB.get("routing_acknowledged", locale);
          btnCancel = MessageDB.get("routing_acknowledge_later", locale);
          statusValue = "Acknowledged";
        }
        else if(taskType.equals("Information")){
          btnYes    = MessageDB.get("routing_remove", locale);
          btnCancel = MessageDB.get("routing_remove_later", locale);
          statusValue = "Acknowledged";
        }
        //Singapore team AR3515 route in order doesn't work, AR3516 route job never finished,check progress,completion, due date don't work
        if(!btnReadOnly){//AR6202+ %>
          <input type="submit" name="subApprove" value="<%= btnYes %>" onClick="reqbase.status.value='<%=statusValue%>'" />&nbsp;
          <%if(taskType.equals("Approval")){%>
            <input type="submit" name="subDisapprove" value="<%= btnNo %>" onClick="reqbase.status.value='Disapproved'" />&nbsp;
          <%}%>
        <input type="submit" name="subResLater" value="<%= btnCancel %>" onClick="reqbase.status.value='Respond Later'" />
        <%}//AR6202+ %>
    </div>
        <input type="hidden" name="status", value="" />
        <% /* Singapore team AR3515, AR3516 */ %>
        <input type="hidden" name="recipient", value="<%= recipient %>" />
        <input type="hidden" name="routingSlipRequestID", value="<%= routingSlipRequestID %>" />
        <%
        if (workFlowJobName != null) {
          %>
          <input type="hidden" name="workFlowJobName", value="<%= workFlowJobName %>" />
        <%}%>
    </form>
        <%
    }catch(Throwable ex) {
        //ex.printStackTrace();
        //System.out.println("request_base: "+ex);
        out.print("</table><br>"+ ex); //MessageDB.get("routing_error_accessing_processor", locale)
        ex.printStackTrace(response.getWriter());
    }
}//end else for display
%>
    <p class="routing_wizard_copyright"><%= MessageDB.get("xerox_copyright", locale) %></p>
</div>
</body>
</html>
<%long t1 = System.currentTimeMillis();
out.print("\n<!-- "+(t1-t0)+" ms -->");
%>
